- MongoDB C Driver 1.13.1 »
- API Reference »
- mongoc_database_t

# mongoc_database_find_collections_with_opts()

## Synopsis

    mongoc_cursor_t *
    mongoc_database_find_collections_with_opts (mongoc_database_t *database,
                                                const bson_t *opts);

Fetches a cursor containing documents, each corresponding to a collection on this database.

To get collection names only, use mongoc_database_get_collection_names_with_opts().

## Parameters

- `database`: A mongoc_database_t.
- `opts`: A `bson_t` containing additional options.

`opts` may be NULL or a BSON document with additional command options:

- `sessionId`: First, construct a mongoc_client_session_t with mongoc_client_start_session(). You can begin a transaction with mongoc_client_session_start_transaction(), optionally with a mongoc_transaction_opt_t that overrides the options inherited from `database`, and use mongoc_client_session_append() to add the session to `opts`. See the example code for mongoc_client_session_t.
- `serverId`: To target a specific server, include an int32 “serverId” field. Obtain the id by calling mongoc_client_select_server(), then mongoc_server_description_id() on its return value.

For a list of all options, see the MongoDB Manual entry on the listCollections command.

## Errors

Use mongoc_cursor_error() on the returned cursor to check for errors.

## Returns

A cursor where each result corresponds to the server’s representation of a collection in this database.

The cursor functions mongoc_cursor_set_limit(), mongoc_cursor_set_batch_size(), and mongoc_cursor_set_max_await_time_ms() have no use on the returned cursor.

## Examples

    {
       bson_t opts = BSON_INITIALIZER;
       bson_t name_filter;
       const bson_t *doc;
       bson_iter_t iter;
       bson_error_t error;

       BSON_APPEND_DOCUMENT_BEGIN (&opts, "filter", &name_filter);
       /* find collections with names like "abbbbc" */
       BSON_APPEND_REGEX (&name_filter, "name", "ab+c", NULL);
       bson_append_document_end (&opts, &name_filter);

       cursor = mongoc_database_find_collections_with_opts (database, &opts);
       while (mongoc_cursor_next (cursor, &doc)) {
          bson_iter_init_find (&iter, doc, "name");
          printf ("found collection: %s\n", bson_iter_utf8 (&iter, NULL));
       }

       if (mongoc_cursor_error (cursor, &error))
          fprintf (stderr, "%s\n", error.msg);
       }

       mongoc_cursor_destroy (cursor);
       bson_destroy (&opts);
    }

## See Also

mongoc_database_get_collection_names_with_opts()

Created using Sphinx 1.8.3, based on Sphinx Readable Theme.